
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>
#include <dir.h>
#include <dos.h>
#include <ctype.h>
#include <conio.h>

#include "midifile.h"
#include "lmuse.h"


#define DIVISION 96


float dmultiplier=4.0;
#define DMULTMAX 4.0
#define PSPREADMAX 4.0
#define DSPREADMAX 8.0
#define VSPREADMAX 8.0
float pspread=1.0;
float dspread=1.0;
float vspread=1.0;

int recurse;
extern char commentchar;

float deg2rad (float deg);
float getfloat ();
int saveproduction();
int savemutatedrules();
int mutaterules();
int interpret (int mode);

int savemidi();
char * changefileext(char * origfilename,char * newfilename, char * newext);

/*prod.c*/
int L_mutate(void);
int makeproduction(int maxlevel);
int readrulefile(FILE *fp); int initrules();
char * formatline(char *line);
extern char *production;
extern long maxstringlength;
extern char *rules[];
extern FILE *rulefilefp;
extern char axiom[];
extern char productionmessage[];

char logfile[12]="LMUSE.LOG";
FILE * log_fp;
#include <stdarg.h>
void l_printf(char *format,...)
{
   char buf[1024];

   va_list ap;
   va_start(ap, format);
   vsprintf(buf, format, ap);
   va_end(ap);

   printf(buf);
   if(log_fp)
       fprintf(log_fp,buf);

}

FILE *savemf_fp;
int myputc(int c) {return(putc(c,savemf_fp));}
char savemfname[256] = "";
char mutatefilename[256]="mutation.lm";
char inifile[256]="lmuse.ini";


int readinifile();

char *rulesstring=NULL;

char numrecursestring[8]="";
char deltaanglestring[80]="10.0";
int numrules;
unsigned int rstart,seed;
int randomize_p=1;
float deflscale;
int maxlevel;
float thick=10.0;
float deltaangledeg=10.0;
float deltaanglerad=10.0*PI/180.0;

float curdrawlength;

int numobjects;

int curchar;
int prevchar;
int showproductions=0;
int originalmutated=0;

int factstacks_p=0;
int transposestack_p=0;

int writeparameters_p=1;
int splittracksbyprogram=0;
char productionfilename[256]="prod.out";
char productionname[80];
int saveproduction_p=0;

char rulefile[256]="";
char rulefilename[80]="";

int division=DIVISION;
long mtempo;
long tempo=120;
int baset;

typedef struct variable{
  float *v;
  int variabletype;
  float *mymin,*mymax;
}VARIABLE;

unsigned makeseed(){
     struct time t;
     gettime(&t);
     return (unsigned)(t.ti_hund*t.ti_sec);
}
unsigned lastseed;
void randomize (){
     lastseed=makeseed();
     srand (lastseed);
}


float dirmax=1.0;
float dirmin=-1.0;

float maxx=0,maxy=0,maxz=0,minx=0,miny=0,minz=0;
float fmaxx=0,fmaxy=0,fmaxz=0,fminx=0,fminy=0,fminz=0;
float umaxx=0,umaxy=0,umaxz=0,uminx=0,uminy=0,uminz=0;
float lmaxx=0,lmaxy=0,lmaxz=0,lminx=0,lminy=0,lminz=0;
float maxlength;
float minlength;
float maxdrawlength;
float mindrawlength;

float maxthickness;
float minthickness;

/*
void debugnothing(){

        char * n="floooooooo";
}
*/
typedef struct vector{
        float x;
        float y;
        float z;
} VECTOR;

VECTOR sky={0.0,1.0,0.0};

void cross (VECTOR *v , VECTOR *w, VECTOR *r);
void xrot (VECTOR *v , VECTOR *vn , float theta);
void yrot (VECTOR *v , VECTOR *vn , float theta);
void zrot (VECTOR *v , VECTOR *vn , float theta);
void rotate (VECTOR *t, VECTOR *v, VECTOR *r, float a);

struct map;
typedef struct state{
        float deltaangle;
        float x,y,z;
        VECTOR fdirection;
        VECTOR udirection;
        VECTOR ldirection;
        float length;
        float thickness;
        int clr;
        int transpose;
        float dfact;
        float vfact;

        long cumtime;
        long prevcumtime;
        int track;
        int inpoly;
        struct map * mymap;
}STATE;


#define STACKDEPTH  2*1024
long timestack[STACKDEPTH];
int timestacktop=0;
void pushtime(long t){
     timestack[timestacktop]=t;

     timestacktop++;
}
long poptime(){

     if (timestacktop<1){


        return timestack[0];
     }
     return timestack[--timestacktop];

}

STATE statestack[STACKDEPTH];
int stacktop=0;

void pushstate(STATE s){


     statestack[stacktop]=s;

     stacktop++;
}
STATE popstate(){

     if (stacktop<1){


        return statestack[0];
     }
     return statestack[--stacktop];

}

STATE curstate;


#define NOTEOFF       0x80
#define NOTEON        0x90
#define KAFTERTOUCH   0xa0
#define CNTRL_CHG     0xb0
#define PRG_CHG       0xc0
#define CHAFTERTOUCH  0xd0
#define PITCHBEND     0xe0
#define SYSTEM        0xf0


typedef struct scale{
	int *s;
	int num;
}SCALE;
/* new scales need to be added here ...*/
int Twelvetone[13] = {0,1,2,3,4,5,6,7,8,9,10,11,12};
int Major[8] = {0,2,4,5,7,9,11,12};
int Penta1[6] = {0,4,7,9,10,12};
int minor[8]={0,2,3,5,7,8,11,12};
int blue1[9]={0,2,3,4,7,8,9,10,12};
int whole[7]={0,2,4,6,8,10,12};
int diminished[9]={0,1,3,4,6,7,9,10,12};

/*...here... */
SCALE scales[7]={
      {Twelvetone,12},{ Major ,7},{ Penta1 ,5},
      {minor,7},{blue1,8},{whole,6},{diminished,8}};
int numpredefinedscales=7;

/*... here ... */
char * scalenames[9]
={"twelve tone","Major","Penta 1","minor","blue 1","whole","diminshed","user's"};


SCALE * cur_scale=&(scales[1]);
SCALE * def_scale=NULL;
SCALE * user_defined_scale=NULL;
int do_getuserscale();
char scalenamestring[40];
char scalefnnamestring[40];


int ignscale(), scalesteps(), slidetoscale(),constantscale();
int (*scalefunctions[4])(int,SCALE *)={slidetoscale,scalesteps,constantscale};
int (*scalefn)(int, SCALE*)=slidetoscale;
int (*defscalefn)(int, SCALE *)=slidetoscale;

char * scalefnnames[5]={"slide to","steps","constant"};

int ignscale(int pitch,SCALE *S __attribute__ ((unused)) )
{
	return (pitch&0x7f);
}

int constantscale(int pitch __attribute__ ((unused)),SCALE *S __attribute__ ((unused)) )
{
        return 0;
}

int scalesteps(int pitch,SCALE *S)
/*finds the pth member of the scale*/
{
	int oct,deg,n=S->num;
        int cnt=0;
	int *sc = S->s;
        int per=sc[n];
        while(pitch<0){
             cnt++;
             pitch+=n;
        }
	oct = (pitch)/(n);
	deg = (pitch)%(n);
	/*degm= deg/(n);
	deg = deg%(n);*/
        return ( (sc[deg]+(oct-cnt)*(per)) & 0x7f);
}

int slidetoscale(int pitch,SCALE *S)
/*returns first scale note higher or equal to given pitch*/
{
        int i=0,per,oct,origdeg;
        int cnt=0;
	int * sc = S->s;
	per     = sc[S->num];
        while (pitch<0){
              cnt++;
              pitch+=per;
        }
        oct     = pitch/per;
        origdeg = pitch%per;
	while(sc[i]<origdeg) i++;
	return((sc[i]+(oct-cnt)*per)&0x7f);

}
char scalestring[60]="";

void scale2scalestring(SCALE* scale){
        int i;
        char *c=scalestring;
        int *scalenotes;
        int numnotes;
        char buf[5];

        scalenotes=scale->s;
        numnotes=scale->num;
        *c='\0';
        for(i=0;i<numnotes;i++){
              itoa(scalenotes[i]+1,buf,10);
              strcat(scalestring,buf);
              strcat(scalestring, " ");
        }

}
SCALE * string2scale(char * str){

  int numsteps=0,i;
  int tempscale[50];
  int *scalenotes;
  int step=0;
  SCALE * newscale;
  char buf[60];
  char *tok;

  if(*str=='\0') return NULL;
  newscale= (SCALE *)malloc(sizeof(SCALE));
  if(newscale==NULL) return NULL;
  strcpy(buf,str);
  tok=strtok(buf," ,");
  if(tok!=NULL)
        step=atoi(tok);
  if (step>0){
     tempscale[numsteps]=step-1;
     numsteps++;
  }

  while (tok!=NULL){
            tok=strtok(NULL, " ,");
            if(tok!=NULL){
               step=atoi(tok);
               if (step>0){
                  tempscale[numsteps]=step-1;
                  numsteps++;
               }
            }
  }

  if (numsteps <=0) {
     if(newscale!=NULL)
          free(newscale);
     return NULL;
  }
  else{
     scalenotes=(int*)malloc(sizeof(int)*numsteps+1);
     if(scalenotes==NULL){
        if (newscale!=NULL)
            free(newscale);

        free(scalenotes);
        return NULL;
     }
     for(i=0;i<numsteps;i++)
           scalenotes[i]=tempscale[i];
     scalenotes[numsteps]=scalenotes[0]+12*(1+ (int)(tempscale[numsteps-1]/12));
     newscale->s=scalenotes;
     newscale->num=numsteps;
  }
  return newscale;
}



int do_getuserscale(){

     user_defined_scale=string2scale(scalestring);
     if(user_defined_scale !=NULL)
         scale2scalestring(user_defined_scale);
     return 0;
}

typedef struct map{
     VARIABLE *pitch;
     VARIABLE *duration;
     VARIABLE *volume;
     float pspread;
     float dspread;
     float vspread;

     float dmultiplier;

     SCALE scale;

     int (*scalefn)(int, SCALE*);
     char scalename[80];
     int transpose;
     int tstack;
     int fstacks;
     unsigned int rstart;

}MAP;

#define MAXMAPS 10
MAP maps[MAXMAPS];



typedef struct midi_chan_event{
     unsigned long t;
     unsigned char status;
     unsigned char data1;
     unsigned char data2;
}MIDICHANEVENT;

typedef struct midi_note_list{
     struct midi_chan_event m;
     struct midi_note_list  * next;
     struct midi_note_list  * prev;
}MIDINOTELIST;
MIDINOTELIST * tracklist[MAXTRACKS];
MIDINOTELIST * tracklastnode[MAXTRACKS];
MIDINOTELIST * tracknextnode[MAXTRACKS];
MIDINOTELIST *next_node;
int maxactivetracks=0;
int next_track;
long trackcumtime[MAXTRACKS]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
long trackprevcumtime[MAXTRACKS]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
unsigned char trackflags[MAXTRACKS]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
#define ACTIVE 1
unsigned char trackchannel[MAXTRACKS]={0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};
long next_event_time;
long maxcumtime;

MIDINOTELIST *
makenewnode()
{
     MIDINOTELIST * mlist= (MIDINOTELIST *)malloc(sizeof(MIDINOTELIST));
     if (mlist==NULL){
        l_printf("\nmidinotelist allocation error\n");
        exit(1);
     }
     mlist->next=NULL;
     mlist->prev=NULL;

     return mlist;
}

MIDINOTELIST *
findlast(L) MIDINOTELIST * L;
{
	MIDINOTELIST * this_node;
	this_node=L;
        if(this_node==NULL) return (this_node);
	while(this_node->next != NULL)
		this_node=this_node->next;
	
	return (this_node);
}

MIDINOTELIST *
findtime(L, tm) MIDINOTELIST * L; unsigned long tm;
{
/*supposed to return the last node whose time is less than or equal to tm*/
	MIDINOTELIST * this_node;
	long accumtime=0L;

	this_node=L;
	while(this_node != NULL){
		accumtime += this_node->m.t;
		if(this_node->next != NULL){

			if(accumtime+(this_node->next->m.t)>tm)
				return (this_node);
			this_node=this_node->next;
		}
		else return (this_node);
	}
        return NULL;
}

MIDINOTELIST * 
appendnewnode(last_node) MIDINOTELIST * last_node;
{  
        MIDINOTELIST * this_node;
        this_node = makenewnode();

        this_node->prev  = last_node;

	if(last_node != NULL)
        	(last_node)->next  = this_node;

        return (this_node);
}

void insertnode(afterme, newL)  MIDINOTELIST * afterme, * newL;
{
	MIDINOTELIST * oldnxt;
	if(afterme !=NULL){
		oldnxt = afterme->next;
		afterme->next = newL;
	}
	else	oldnxt=NULL;
	newL->next = oldnxt;
	newL->prev = afterme;
	if(oldnxt !=NULL)
		oldnxt->prev = newL;
}

MIDINOTELIST *insertattime(MIDINOTELIST * *L,MIDINOTELIST *newL,unsigned long attime, int priority){

        MIDINOTELIST * afterme;
        MIDINOTELIST * beforeme;
        MIDINOTELIST * this_node;
	unsigned long accumtime=0L;

	this_node=*L;
        if(this_node->m.t<attime || (this_node->m.t==attime && priority <1)){
	    while(this_node != NULL){
		accumtime += this_node->m.t;
                if(accumtime==attime && priority==1){
                          newL->next=this_node;
                          newL->prev=this_node->prev;
                          if(this_node->prev)
                               (this_node->prev)->next=newL;
                          this_node->prev=newL;
                          newL->m.t=this_node->m.t;
                          this_node->m.t=0;
                          return newL;
                }
		if(this_node->next != NULL){


			if(accumtime+(this_node->next->m.t)>attime)
				break;
			this_node=this_node->next;
		}
		else break;
	     }
        }
        else{  /* attime goes at beginning of list */
             *L=newL;
             newL->next=this_node;
             newL->prev=NULL;
             newL->m.t=attime;
             this_node->m.t -= attime;
             this_node->prev=newL;
             return newL;
        }
        afterme=this_node;
        beforeme=this_node->next;
        newL->m.t = attime-accumtime;
        if(beforeme!=NULL){ /*attime is before the end of the list*/
             beforeme->m.t -= newL->m.t;
             beforeme->prev=newL;
        }
        newL->prev=afterme;
        newL->next=beforeme;
        afterme->next=newL;


        return(newL);
}

MIDINOTELIST *insertlistattime(MIDINOTELIST * *L,MIDINOTELIST *newL,unsigned long attime){

        MIDINOTELIST * afterme;
        MIDINOTELIST * beforeme;
        MIDINOTELIST * this_node;
        MIDINOTELIST * end_node;
	unsigned long accumtime=0L;
        /*first find the end node of the list to be added*/
        this_node=newL;
        end_node=newL;
        while(this_node->next !=NULL){
             end_node=this_node->next;
             this_node=end_node;
        }


	this_node=*L;
        if(this_node->m.t<attime){
	    while(this_node != NULL){
		accumtime += this_node->m.t;
                if(this_node->next != NULL){


			if(accumtime+(this_node->next->m.t)>attime)
				break;
			this_node=this_node->next;
		}
		else break;
	     }
        }
        else{  /* attime goes at beginning of list */
             *L=newL;
             end_node->next=this_node;
             newL->prev=NULL;
             newL->m.t=attime;
             this_node->m.t -= attime;
             this_node->prev=end_node;
             return newL;
        }
        afterme=this_node;
        beforeme=this_node->next;
        newL->m.t = attime-accumtime;
        if(beforeme!=NULL){ /*attime is before the end of the list*/
             beforeme->m.t -= newL->m.t;
             beforeme->prev=end_node;
        }
        newL->prev=afterme;
        end_node->next=beforeme;
        afterme->next=newL;


        return(newL);
}

/*this only works if the list has an end!*/
void free_midi_note_list( M ) MIDINOTELIST  * M;
{
     MIDINOTELIST * current_element = M;
     MIDINOTELIST * next_element;
     if(M != NULL && M->prev != NULL) (M->prev)->next=NULL;     
     while(current_element != NULL){
          next_element = current_element->next;
          free(current_element);
          current_element = next_element;
     }
     
}

float zerolength=0.0;

#define COORDINATE 1
#define DIRECTION 2
#define LENGTH 3

#define NUMSTATEVARS 15
#define X_VAR 0
#define Y_VAR 1
#define Z_VAR 2
#define FX_VAR 3
#define FY_VAR 4
#define FZ_VAR 5
#define UX_VAR 6
#define UY_VAR 7
#define UZ_VAR 8
#define LX_VAR 9
#define LY_VAR 10
#define LZ_VAR 11
#define LENGTH_VAR 12
#define DRAWLENGTH_VAR 13
#define THICKNESS_VAR 14
char *statevariablenames[NUMSTATEVARS]={
     "x","y","z",
     "fx","fy","fz",
     "ux","uy","uz",
     "lx","ly","lz",
     "length","drawlength","thickness"
};
VARIABLE statevariablearray[NUMSTATEVARS]= {
         {&(curstate.x),COORDINATE,&minx,&maxx},
         {&(curstate.y),COORDINATE,&miny,&maxy},
         {&(curstate.z),COORDINATE,&minz,&maxz},
         {&(curstate.fdirection.x),DIRECTION,&fminx,&fmaxx},
         {&(curstate.fdirection.y),DIRECTION,&fminy,&fmaxy},
         {&(curstate.fdirection.z),DIRECTION,&fminz,&fmaxz},
         {&(curstate.udirection.x),DIRECTION,&uminx,&umaxx},
         {&(curstate.udirection.y),DIRECTION,&uminy,&umaxy},
         {&(curstate.udirection.z),DIRECTION,&uminz,&umaxz},
         {&(curstate.ldirection.x),DIRECTION,&lminx,&lmaxx},
         {&(curstate.ldirection.y),DIRECTION,&lminy,&lmaxy},
         {&(curstate.ldirection.z),DIRECTION,&lminz,&lmaxz},
         {&(curstate.length),LENGTH,&minlength,&maxlength},
         {&(curdrawlength),LENGTH,&mindrawlength,&maxdrawlength},
         {&(curstate.thickness),LENGTH,&minthickness,&maxthickness}

};

float fzero=0.0;
VARIABLE constantvar={&fzero,0,0,0};

VARIABLE pitchvariable;
VARIABLE durationvariable;
VARIABLE velocityvariable;


#define PITCH    0
#define DURATION 1
#define VOLUME 2
#define NUMLCONNECT 3

char mapbuf[NUMLCONNECT][80];

float holddmultiplier;
char *get_filename(char *path) //copied straight from allegro file.c
{
   int pos;

   for (pos=0; path[pos]; pos++)
      ; /* do nothing */ 

   while ((pos>0) && (path[pos-1] != '\\') && (path[pos-1] != '/'))
      pos--;

   return path+pos;
}
char *get_extension(char *filename)
{
   int pos, end;

   for (end=0; filename[end]; end++)
      ; /* do nothing */

   pos = end;

   while ((pos>0) && (filename[pos-1] != '.') &&
	  (filename[pos-1] != '\\') && (filename[pos-1] != '/') &&
	  (filename[pos-1] != '#'))
      pos--;

   if (filename[pos-1] == '.')
      return filename+pos;

   return filename+end;
}


int getrules( char * rulefile){
   int i;
   int maxlevel;


   formatline(rulefile);
   if(*rulefile =='\0'){
                return -1;
   }
   initrules();
   rulefilefp=fopen(rulefile,"r");
   if(rulefilefp==NULL){

          l_printf("\n%s not found\n",rulefile);
          return -1;
   }

   maxlevel=readrulefile(rulefilefp);
   if(recurse==-1){
                   recurse=maxlevel;
   }
   else maxlevel=recurse;
   originalmutated=0;

   sprintf(numrecursestring,"%d",maxlevel);
   sprintf(deltaanglestring,"%3.2f",deltaangledeg);
   fclose(rulefilefp);
   strcpy(rulefilename,get_filename(rulefile));
   changefileext(rulefile,productionfilename,"out");
   if(*savemfname=='\0')
       changefileext(rulefile,savemfname,"mid");
   else
       changefileext(savemfname,savemfname,"mid");
   changefileext(rulefile,mutatefilename,"lm");
   changefileext(get_filename(rulefile),productionname,"");

   l_printf("\nFile:            %s\n", rulefile);
   l_printf("recursion depth: %d\n", maxlevel);
   l_printf("basic angle:     %3.2f\n", deltaangledeg);
   l_printf("axiom:           %s\n",axiom);
   l_printf("transformation rules (%d)\n", numrules);
   for (i=0;i<numrules;i++){
       l_printf("\t%d)   %s\n",i+1,rules[i]);
   }
   return 0;
}


char * makerulesstring(){
     int i;
     int stringlength=0;

     for (i=0;i<numrules;i++)
          stringlength+=(strlen(rules[i])+2);
     if(rulesstring!=NULL)
         free(rulesstring);
     rulesstring=(char *)malloc(sizeof(char)*stringlength+1);

     if(rulesstring!=NULL){
         *rulesstring='\0';
         for (i=0;i<numrules;i++){
           strcat(rulesstring,rules[i]);
           strcat(rulesstring,"\n");
         }
     }

     return rulesstring;
}

char *emptyproduction="(empty)";

void print_curstate(){
     l_printf("Last Turtle State:\nangle=%f,\nx=%f, y=%f, z=%f,\n"
        "fdirection.x=%f, fdirection.y=%f, fdirection.z=%f,\n"
        "udirection.x=%f, udirection.y=%f, udirection.z=%f,\n"
        "ldirection.x=%f, ldirection.y=%f, ldirection.z=%f,\n"
        "length=%f, thickness=%f\n",
        curstate.deltaangle,curstate.x,curstate.y,curstate.z,
        curstate.fdirection.x,curstate.fdirection.y,curstate.fdirection.z,
        curstate.udirection.x,curstate.udirection.y,curstate.udirection.z,
        curstate.ldirection.x,curstate.ldirection.y,curstate.ldirection.z,
        curstate.length, curstate.thickness);
}

int makeaborted;
int makefailed;
FILE *readprod_fp;

#define INTERPRETFILEERROR 1
#define INTERPRETARITHERROR -1
#define INTERPRETARITHERRORINF -2
#define INTERPRETARITHERRORNAN -3
#define INTERPRETOK 0
#define INTERPRETABORT 2
#define INTERPRETSTACKOVERFLOW 3
#define INTERPRETSTACKUNDERFLOW 4

int do_interpretremap(){
   int i;

   int interpretret;



   for(i=0;i<MAXTRACKS;i++){
                  free_midi_note_list( tracklist[i] );
                  tracklist[i]=NULL;
   }
   deltaanglerad = deg2rad(deltaangledeg);
   srand(rstart);

   interpretret=interpret(1);

   if(interpretret<=INTERPRETARITHERROR){

      l_printf("\nArithmetic error while interpreting. Have to quit\n");
      l_printf("\nLast Symbol Interpreted: %c\n",(char)prevchar);

      print_curstate();

      exit(0);

   }
   else if(interpretret==INTERPRETFILEERROR){

        l_printf("\nProduction file error ... Quitting");
        exit(0);
   }
   return 0;
}

int do_interpret(){
   int i;
   int interpretret;

   deltaanglerad = deg2rad(deltaangledeg);
   maxx=0;maxy=0;maxz=0;minx=0;miny=0;minz=0;
   fmaxx=0;fmaxy=0;fmaxz=0;fminx=0;fminy=0;fminz=0;
   umaxx=0;umaxy=0;umaxz=0;uminx=0;uminy=0;uminz=0;
   lmaxx=0;lmaxy=0;lmaxz=0;lminx=0;lminy=0;lminz=0;

   maxlength=0;
   minlength=0;
   maxdrawlength=0;
   mindrawlength=0;

   maxthickness=curstate.thickness;
   minthickness=curstate.thickness;
   numobjects=0;

   for(i=0;i<MAXTRACKS;i++){
    trackcumtime[i]=0L;
    trackprevcumtime[i]=0L;
   }
   /*
   if(randomize_p)
        rstart = makeseed();
   */
   srand(rstart);
   l_printf("\nInterpreting production\n");
   interpretret=interpret(0);


   if( interpretret <= INTERPRETARITHERROR){

        l_printf("Arithmetic error while interpreting. Have to quit");
        l_printf("\nLast Symbol Interpreted: %c\n",(char)prevchar);

        print_curstate();

        exit(0);
   }
   else if(interpretret==INTERPRETFILEERROR){
        l_printf("\nProduction file error ... Quitting\n");
        exit(0);
   }
   else if(interpretret==INTERPRETABORT){
        l_printf("\nInterpretation aborted\n");
        exit(0);

   }
   else if(interpretret==INTERPRETSTACKOVERFLOW){
        l_printf("\nInterpret failed. Stack full!\n");
        exit(0);
   }
   else if(interpretret==INTERPRETSTACKUNDERFLOW){
        l_printf("\nInterpret failed. Pop from empty stack\n");
        exit(0);
   }

   if( numobjects == 0){
        l_printf("\nNo objects. Done.\n");
        return 0;
   }

   return do_interpretremap();
}



char * commandhelpstring1=
"\nuse:\n\tLMUSe [-iI] [-fF] [-rR] [-mM] [-sS] [-t] rulefilename";
char * commandhelpstring2="\nwhere:"
"\n\tI is the filename of a map file for LMUSe (default is 'LMUSE.INI')"
"\n\tF is the filename the MIDI file ouput (default is rulefilename.MID')"
"\n\tR is an override for the number of recursions to perform"
"\n\tM is a number of mutations. Mutated rules are saved to rulefilename.lm"
"\n\tS is the number of kilobytes for production space (default is 2048)"
"\n\t-t splits saved MIDI tracks by instrument";
char * commandhelpstring3=
"\n\trulefilename is the name of the rulefile to use. (Mutating"
"\n\t\ta file which already has an \"lm\" extension will overwrite"
"\n\t\tthe original file)"
"\nThe rulefilename is a required parameter."
"\n-sS, -iI, -rR, -mM, -fF, and -t are optional."
"\nThe order of the options/parameters is unimportant\n";
char * commandhelpstring4="\nFor example:"
"\n\tLMUSe -iMYINI.INI -fTest -r5 -m3 -t mylsys01.L"
"\ntells LMUSe to read the l-system file 'mylsys01.L', mutate it"
"\n3 times (-m3), perform 5 recursions of the rules (-r5), interpret"
"\nthe results according to the map in the file 'MYINI.INI'(-iMYINI.INI),"
"\nand put the result in the MIDI file 'Test.MID' (-fTest), splitting up"
"\nmulti-instrument tracks into separate tracks (-t).\n";
char * commandhelpstring5=
"\n\tLMUSe mylsys01.L"
"\ntells LMUSe to read the l-system file 'mylsys01.L', perform the number"
"\nof recursions contained in mylsys01.L, interpret the results according"
"\nto the map in the default file 'LMUSE.INI', and put the result in the"
"\nMIDI file 'mylsys01.MID'\n";


int nummutate=0;
int main(int argc,char *argv[]){

   int numargs=argc-1;
   char argvbuf[80];
   char *aptr;
   int i,n;

   log_fp=fopen(logfile,"wt");

   l_printf("\n\n%s version %s. Build date: %s. \nRun without a rulefile name to see command line use\n",
   PROGRAMNAME,PROGRAMVERSION, __DATE__);
   randomize();

   initrules();
   deflscale = .9;   /* default scaling for '*/

   recurse = -1;

   strcpy(scalenamestring,scalenames[1]);
   strcpy(scalefnnamestring,scalefnnames[0]);
   pitchvariable=statevariablearray[X_VAR];
   durationvariable=statevariablearray[DRAWLENGTH_VAR];
   velocityvariable=statevariablearray[FX_VAR];

   for(i=0;i<MAXMAPS;i++){
        maps[i].pitch=&statevariablearray[X_VAR];
        maps[i].duration=&statevariablearray[DRAWLENGTH_VAR];
        maps[i].volume=&statevariablearray[FX_VAR];
        maps[i].pspread=pspread;
        maps[i].dspread=dspread;
        maps[i].vspread=vspread;
        maps[i].scale=(scales[1]);
        strcpy(maps[i].scalename,scalenames[1]);
        maps[i].scalefn=scalefunctions[0];
        maps[i].dmultiplier=dmultiplier;
        maps[i].tstack=transposestack_p;
        maps[i].fstacks=factstacks_p;
        maps[i].transpose=0;
   }

   for(n = 1; n<=numargs;n++) {
        strcpy(argvbuf,argv[n]);
        strupr(argvbuf);
        aptr=argvbuf;
        if (*aptr == '-'){
             aptr++;
             if(*aptr=='S'){
                aptr++;
                maxstringlength = 1024*atoi(aptr);
             }
             /**/
             else if(*aptr=='I'){
                aptr++;
                strcpy(inifile,aptr);
             }
             else if(*aptr=='R'){
                aptr++;
                recurse=atoi(aptr);
             }
             else if(*aptr=='M'){
                aptr++;
                nummutate=atoi(aptr);
             }
             else if(*aptr=='F'){
                aptr++;
                strcpy(savemfname,aptr);

             }
             else if(*aptr=='T'){
                splittracksbyprogram=1;
             }

             /**/
        }
        else{
            strcpy(rulefile,aptr);
        }
   }
   if(*rulefile=='\0'){
        l_printf(commandhelpstring1);
        l_printf(commandhelpstring2);
        l_printf(commandhelpstring3);
        l_printf(commandhelpstring4);
        //l_printf(commandhelpstring5);
        exit(0);
   }
   readinifile();
   if(randomize_p)
       rstart = makeseed();
   if(getrules(rulefile)==-1)
        exit(0);
   for(i=0;i<nummutate;i++){

         mutaterules();

   }
   if(nummutate){
         if(originalmutated)
                savemutatedrules();
         else
            l_printf("\nMutations didn't take!\n");
   }
   makeproduction(recurse);
   if(saveproduction_p)
                saveproduction();

   do_interpret();
   mtempo=60000000/tempo;
   savemidi();

   l_printf("\nExiting LMUSe\n");

   if(log_fp) fclose(log_fp);

   for(i=0;i<MAXTRACKS;i++)
           free_midi_note_list( tracklist[i] );

   exit(0);
}

float deg2rad (float deg){
        return (PI * deg / 180.0);
}

void cross (VECTOR *v, VECTOR *w, VECTOR *r){
/* r = v X w;  'r' for 'result'*/
  r->x = v->y * w->z - v->z * w->y;
  r->y = v->z * w->x - v->x * w->z;
  r->z = v->x * w->y - v->y * w->x;
}

void rotate (VECTOR *t , VECTOR *v , VECTOR *r, float a){
/*rotate v around t by angle a. result stored in r*/
    float tx=t->x,ty=t->y,tz=t->z,vx=v->x,vy=v->y,vz=v->z;
    float ac,bc,cc,cosa,sina,gz;
    float R11,R12,R13,R21,R22,R23,R31,R32,R33;
    float tlen = sqrt(tx*tx + ty*ty + tz*tz);
    ac = tx/tlen;
    bc = ty/tlen;
    cc = tz/tlen;
    cosa = cos(a); sina = sin(a);
    gz = 1 - cosa;

    R11 = ac*ac*gz + cosa;    R12 = ac*bc*gz - cc*sina; R13 = ac*cc*gz + bc*sina;
    R21 = ac*bc*gz + cc*sina; R22 = bc*bc*gz + cosa;    R23 = bc*cc*gz - ac * sina;
    R31 = ac*cc*gz - bc*sina; R32 = bc*cc*gz + ac*sina; R33 = cc*cc*gz + cosa;

    r->x = R11*vx + R12*vy + R13*vz;
    r->y = R21*vx + R22*vy + R23*vz;
    r->z = R31*vx + R32*vy + R33*vz;
}


void xrot (VECTOR *v, VECTOR *vn, float theta){
        vn->x = v->x;
        vn->y = (v->y) * cos(theta) - (v->z) * sin(theta);
        vn->z = (v->z) * cos(theta) + (v->y) * sin(theta);
}

void yrot (VECTOR *v, VECTOR * vnew, float theta){

        vnew->x = (v->x) * cos(theta) + (v->z) * sin(theta);
        vnew->y = v->y;
        vnew->z = (v->z) * cos(theta) - (v->x) * sin(theta);
}

void zrot (VECTOR *v, VECTOR *vnew, float theta){
        vnew->x = (v->x) * cos(theta) + (v->y) * sin(theta);
        vnew->y = (v->y) * cos(theta) - (v->x) * sin(theta);
        vnew->z = v->z;
}


int transposestack[STACKDEPTH]={0};
int transposestacktop=0;
void pushtranspose(int t){
     transposestack[transposestacktop]=t;

     transposestacktop++;
}
int poptranspose(){
     if (transposestacktop<1){

                return transposestack[0];
     }
     return transposestack[--transposestacktop];

}

float dfactstack[STACKDEPTH]={1.0};
int dfactstacktop=0;
float vfactstack[STACKDEPTH]={1.0};
int vfactstacktop=0;

void pushdfact(float fact){

     dfactstack[dfactstacktop]=fact;

     dfactstacktop++;
}
float popdfact(){
     if (dfactstacktop<1){
        return dfactstack[0];
     }
     return dfactstack[--dfactstacktop];

}

void pushvfact(float fact){
     vfactstack[vfactstacktop]=fact;
     vfactstacktop++;
}
float popvfact(){
     if (vfactstacktop<1){


        return vfactstack[0];
     }
     return vfactstack[--vfactstacktop];

}


int getapitch();
int getavelocity();
long getaduration();
int count_notes=0;

long inserttracknote(int tracknumber, int on_off){
      int pitch;
      long dur =getaduration();
      int vel=0;
      int channel=trackchannel[tracknumber];
      long cum_time=curstate.cumtime;
      long prev_cum_time=curstate.prevcumtime;
      MIDINOTELIST * last_node;
      prev_cum_time=trackprevcumtime[tracknumber];

      if(on_off){
           pitch = getapitch()&0x7F;
           vel=getavelocity()&0x7F;
      }
      else {
           pitch=0;
           cum_time=cum_time+dur;
      }
      if(pitch>0){

           count_notes++;
           /*make the note_on node*/
           last_node=makenewnode();
           if(tracklist[tracknumber]==NULL){
                tracklist[tracknumber]=last_node;
                last_node->m.t=cum_time-prev_cum_time;
           }
           else
                insertattime(&tracklist[tracknumber],last_node,cum_time,0);
           last_node->m.status=NOTEON|channel;
           last_node->m.data1=pitch;
           last_node->m.data2=vel;

           /*make the note_off*/
           last_node=makenewnode();

           insertattime(&tracklist[tracknumber],last_node,cum_time+dur,0);

           last_node->m.status=NOTEOFF|channel;
           last_node->m.data1=pitch;
           last_node->m.data2=0;

           trackprevcumtime[tracknumber]=cum_time+dur;
           curstate.prevcumtime=cum_time+dur;

           tracklastnode[tracknumber]=last_node;

           trackflags[tracknumber]|=ACTIVE;
      }
      curstate.cumtime+=dur;

      return dur;
}
long insertpatchandnote(int tracknumber){

      int program =curstate.clr%127;

      int pitch;
      long dur =getaduration();
      int vel;
      int channel=trackchannel[tracknumber];
      long cum_time=curstate.cumtime;
      long prev_cum_time=curstate.prevcumtime;
      MIDINOTELIST * patch_node,*note_node;

      prev_cum_time=trackprevcumtime[tracknumber];
      pitch = getapitch()&0x7F;
      vel=getavelocity()&0x7F;
      if(pitch>0){

           count_notes++;
           /*make the note_on node*/
           patch_node=makenewnode();
           note_node=makenewnode();
           patch_node->next=note_node;
           note_node->prev=patch_node;
           note_node->m.t=0L;

           if(tracklist[tracknumber]==NULL){
                tracklist[tracknumber]=patch_node;
                patch_node->m.t=cum_time-prev_cum_time;
           }
           else
                insertlistattime(&tracklist[tracknumber],patch_node,cum_time);
           patch_node->m.status=PRG_CHG|channel;
           patch_node->m.data1=program;
           patch_node->m.data2=0;
           note_node->m.status=NOTEON|channel;
           note_node->m.data1=pitch;
           note_node->m.data2=vel;

           /*make the note_off*/
           note_node=makenewnode();

           insertattime(&tracklist[tracknumber],note_node,cum_time+dur,0);

           note_node->m.status=NOTEOFF|channel;
           note_node->m.data1=pitch;
           note_node->m.data2=0;

           trackprevcumtime[tracknumber]=cum_time+dur;
           curstate.prevcumtime=cum_time+dur;

           tracklastnode[tracknumber]=note_node;

           trackflags[tracknumber]|=ACTIVE;
      }
      curstate.cumtime+=dur;

      return dur;
}

void inserttrackpatch(int tracknumber){
      long program =curstate.clr%127;

      int channel=trackchannel[tracknumber];
      long cum_time=curstate.cumtime;
      long prev_cum_time=curstate.prevcumtime;
      MIDINOTELIST * last_node;

      count_notes++;
      /*make the note_on node*/
      last_node=makenewnode();
      if(tracklist[tracknumber]==NULL){
                tracklist[tracknumber]=last_node;
                last_node->m.t=cum_time-prev_cum_time;
      }
      else
           insertattime(&tracklist[tracknumber],last_node,cum_time,1);
      last_node->m.status=PRG_CHG|channel;
      last_node->m.data1=program;

      tracklastnode[tracknumber]=last_node;

      trackflags[tracknumber]|=ACTIVE;
}


int basenote=60;
#define FPZERODIF 1e-5

int getapitch(){
      int pitch;
      VARIABLE p=pitchvariable;
      float pwide=*p.mymax-*p.mymin;
      float midp=(*p.mymax+*p.mymin)/2;

      if(pwide>FPZERODIF){

                 pitch=basenote+curstate.transpose+curstate.mymap->transpose+scalefn( pspread*(*p.v-midp)*30/pwide ,cur_scale);
      }
      else
                 pitch=basenote+curstate.transpose+curstate.mymap->transpose+scalefn( 0,cur_scale);
      return pitch;
}


long getaduration(){
      long dur;
      VARIABLE d=durationvariable;
      float dwide=*d.mymax-*d.mymin;
      float midd=(*d.mymax+*d.mymin)/2;

      if(dwide>FPZERODIF){

                 dur=curstate.dfact*dmultiplier*division/8*pow(2,dspread*(*d.v-midd)/dwide);
      }
      else
                 dur=curstate.dfact*dmultiplier*division/8*pow(2,0);

      return dur;
}


int getavelocity(){
      int vel;
      VARIABLE v=velocityvariable;
      float vwide=*v.mymax-*v.mymin;
      float midv=(*v.mymax+*v.mymin)/2;

      if(vwide>FPZERODIF){

                 vel=64+ vspread*(*v.v-midv)*30/vwide;
      }
      else   vel=64;
      vel=(int)(curstate.vfact*vel);
      if (vel>0x7F) vel=0x7F;
      return (vel);
}


MIDINOTELIST * findmynoteoff(MIDINOTELIST * me,long * dur){
         long accumtime=0L;
         MIDINOTELIST * cur_node=me->next;
         MIDICHANEVENT m=me->m;
         int stat;
         int mychannel=m.status&0x0F,channel;
         int mypitch=m.data1;
         while(cur_node!=NULL){
                stat=cur_node->m.status&0xF0;
                channel=cur_node->m.status&0x0F;
                accumtime+=cur_node->m.t;
                if(stat==NOTEOFF && channel==mychannel){
                    if(cur_node->m.data1==mypitch){
                              *dur=accumtime;
                              return cur_node;
                    }
                }
                cur_node=cur_node->next;
         }
         return cur_node;
}

void getvariablelimits(){
   if( curstate.x > maxx ) maxx = curstate.x;
   if( curstate.x < minx ) minx = curstate.x;
   if( curstate.y > maxy ) maxy = curstate.y;
   if( curstate.y < miny ) miny = curstate.y;
   if( curstate.z > maxz ) maxz = curstate.z;
   if( curstate.z < minz ) minz = curstate.z;
   if( curstate.fdirection.x > fmaxx ) fmaxx = curstate.fdirection.x;
   if( curstate.fdirection.x < fminx ) fminx = curstate.fdirection.x;
   if( curstate.fdirection.y > fmaxy ) fmaxy = curstate.fdirection.y;
   if( curstate.fdirection.y < fminy ) fminy = curstate.fdirection.y;
   if( curstate.fdirection.z > fmaxz ) fmaxz = curstate.fdirection.z;
   if( curstate.fdirection.z < fminz ) fminz = curstate.fdirection.z;
   if( curstate.udirection.x > umaxx ) umaxx = curstate.udirection.x;
   if( curstate.udirection.x < uminx ) uminx = curstate.udirection.x;
   if( curstate.udirection.y > umaxy ) umaxy = curstate.udirection.y;
   if( curstate.udirection.y < uminy ) uminy = curstate.udirection.y;
   if( curstate.udirection.z > umaxz ) umaxz = curstate.udirection.z;
   if( curstate.udirection.z < uminz ) uminz = curstate.udirection.z;
   if( curstate.ldirection.x > lmaxx ) lmaxx = curstate.ldirection.x;
   if( curstate.ldirection.x < lminx ) lminx = curstate.ldirection.x;
   if( curstate.ldirection.y > lmaxy ) lmaxy = curstate.ldirection.y;
   if( curstate.ldirection.y < lminy ) lminy = curstate.ldirection.y;
   if( curstate.ldirection.z > lmaxz ) lmaxz = curstate.ldirection.z;
   if( curstate.ldirection.z < lminz ) lminz = curstate.ldirection.z;

   if(curstate.length>maxlength)maxlength=curstate.length;
   if(curstate.length<minlength)minlength=curstate.length;
   if(curdrawlength>maxdrawlength)maxdrawlength=curdrawlength;
   if(curdrawlength<mindrawlength)mindrawlength=curdrawlength;
   if(curstate.thickness>maxthickness)maxthickness=curstate.thickness;
   if(curstate.thickness<minthickness)minthickness=curstate.thickness;
}
void initvariablelimits(){

   fmaxx = curstate.fdirection.x;
   fminx = curstate.fdirection.x;
   fmaxy = curstate.fdirection.y;
   fminy = curstate.fdirection.y;
   fmaxz = curstate.fdirection.z;
   fminz = curstate.fdirection.z;
   umaxx = curstate.udirection.x;
   uminx = curstate.udirection.x;
   umaxy = curstate.udirection.y;
   uminy = curstate.udirection.y;
   umaxz = curstate.udirection.z;
   uminz = curstate.udirection.z;
   lmaxx = curstate.ldirection.x;
   lminx = curstate.ldirection.x;
   lmaxy = curstate.ldirection.y;
   lminy = curstate.ldirection.y;
   lmaxz = curstate.ldirection.z;
   lminz = curstate.ldirection.z;

   maxlength=curstate.length;
   minlength=curstate.length;
   maxdrawlength=curdrawlength;
   mindrawlength=curdrawlength;
   maxthickness=curstate.thickness;
   minthickness=curstate.thickness;
}


#include <signal.h>

void arithmeticerrorhandler(){


        l_printf("Arithmetic error while interpreting. Quitting");
        l_printf("\nLast symbol interpreted: %c\n",(char)prevchar);

        print_curstate();

        exit(0);


}

void setmapto(int mapnumber){
     pitchvariable=*(maps[mapnumber].pitch);
     durationvariable=*(maps[mapnumber].duration);
     velocityvariable=*(maps[mapnumber].volume);
     pspread=maps[mapnumber].pspread;
     dspread=maps[mapnumber].dspread;
     vspread=maps[mapnumber].vspread;
     dmultiplier=maps[mapnumber].dmultiplier;
     transposestack_p=maps[mapnumber].tstack;
     factstacks_p=maps[mapnumber].fstacks;

}

int checkvariablewidths(){
        int i;
        float pwd,dwd,vwd;
        for(i=0;i<MAXMAPS;i++){
            pwd=*(maps[i].pitch->mymax)-*(maps[i].pitch->mymin);
            dwd=*(maps[i].duration->mymax)-*(maps[i].duration->mymin);
            vwd=*(maps[i].volume->mymax)-*(maps[i].volume->mymin);
            if(isinf(pwd) ||isinf(dwd)||isinf(vwd)){

                return -1;
            }
        }
        return 0;
}

int maxcolor =255;
char *inptr;
int interpret (int mode){
/*
call interpret(mode) twice:
mode==0 -> just go through and find limits, number of objects, etc.
mode==1 -> actually make midi lists
*/
     int mapnumber;
     VECTOR u,v;
     VECTOR df,du,dl;
     float x,y,z;
     float dang;
     float length;
     int transpose;
     float dfact,vfact;
     float lscale;
     int clr;
     float maxrandomturn;
     float xturn,yturn,zturn;
     char thischar;
     int track;
     long holdtime;
     int interpretret=INTERPRETOK;
     int rcount=0;
     int firstdraw=1;

     setmapto(0);
     signal(SIGFPE, arithmeticerrorhandler);

     if(mode==1){

        if(checkvariablewidths()<0){

                return INTERPRETARITHERRORINF;

        }
     }
     df.x = 0; df.y = 1; df.z = 0;
     du.x = 1; du.y = 0; du.z = 0;
     dl.x = 0; dl.y = 0; dl.z = 1;

     curstate.deltaangle=deltaanglerad;
     curstate.x = 0; curstate.y = 0; curstate.z = 0;
     curstate.fdirection = df;curstate.udirection = du; curstate.ldirection = dl;
     curstate.length = 10; curstate.clr = 0; curstate.thickness = thick;
     curstate.track=0;curstate.cumtime=0L;curstate.prevcumtime=0L;
     curstate.transpose=0;   curstate.dfact=1.0; curstate.vfact=1.0;
     curstate.inpoly=0;
     curstate.mymap=&maps[0];
     curdrawlength=10;
     maxcumtime=0L;
     stacktop = 0;

     inptr=production;

     curchar = *inptr++;



     while( curchar != '\0'){
        rcount++;
        if(rcount%100==0){
           printf(".");fflush(stdout);
           rcount=0;
        }
        x = curstate.x; y = curstate.y; z = curstate.z;
        pitchvariable=*(curstate.mymap->pitch);
        durationvariable=*(curstate.mymap->duration);
        velocityvariable=*(curstate.mymap->volume);
        pspread=curstate.mymap->pspread;
        dspread=curstate.mymap->dspread;
        vspread=curstate.mymap->vspread;
        dmultiplier=curstate.mymap->dmultiplier;
        cur_scale=&(curstate.mymap->scale);
        scalefn=curstate.mymap->scalefn;

        if(isinf(x)||isinf(y)||isinf(z)||isinf(curstate.length)||isinf(curstate.thickness)){

               return INTERPRETARITHERRORINF;
        }


        prevchar=curchar;
        switch(curchar){
                 case 'F':
                 case 'f':
                 case 'g':
                        thischar = curchar;
                        length = getfloat();
                        if(length <= 0)
                            length = curstate.length;

                        curstate.x = curstate.x + length * (curstate.fdirection.x);
                        curstate.y = curstate.y + length * (curstate.fdirection.y);
                        curstate.z = curstate.z + length * (curstate.fdirection.z);
                        curdrawlength=length;
                        if(mode == 0){
                                if(thischar == 'F'|| (curstate.inpoly == 1 && thischar != 'g'))  numobjects++;
                                if(firstdraw){
                                    initvariablelimits();
                                    firstdraw=0;
                                }
                        }

                        else if( mode == 1){
                                if(thischar == 'F' || (curstate.inpoly == 1 && thischar != 'g')){
                                     insertpatchandnote(curstate.track);

                                }
                                else {
                                    inserttracknote(curstate.track,0);
                                }
                        }
                        break;
                 case 'Z':
                 case 'z':
                        thischar = curchar;
                        length = getfloat();
                        if( length <= 0)
                                length = curstate.length;
                        else length = 2 * length;
                        curdrawlength=length/2;
                        curstate.x = curstate.x + length / 2 * (curstate.fdirection.x);
                        curstate.y = curstate.y + length / 2 * (curstate.fdirection.y);
                        curstate.z = curstate.z + length / 2 * (curstate.fdirection.z);

                        if( mode == 0){
                                if(thischar == 'Z'|| (curstate.inpoly == 1 && thischar != 'g'))  numobjects++;
                                if(firstdraw){
                                    initvariablelimits();
                                    firstdraw=0;
                                }

                        }
                        else if( mode == 1){
                               if(thischar == 'Z' || curstate.inpoly == 1){
                                      insertpatchandnote(curstate.track);



                                }
                                else{
                                   inserttracknote(curstate.track,0);
                                }
                        }
                        break;
                 case '$':
                        curchar = *inptr++;
                        if( curstate.fdirection.x != 0 && curstate.fdirection.z != 0){
                                cross(&(curstate.fdirection), &sky, &(curstate.ldirection));
                                cross(&(curstate.fdirection), &(curstate.ldirection),&(curstate.udirection));
                        }
                        break;
                 case '|':
                        curchar = *inptr++;
                        curstate.fdirection.x = -curstate.fdirection.x;
                        curstate.fdirection.y = -curstate.fdirection.y;
                        curstate.fdirection.z = -curstate.fdirection.z;
                        curstate.ldirection.x = -curstate.ldirection.x;
                        curstate.ldirection.y = -curstate.ldirection.y;
                        curstate.ldirection.z = -curstate.ldirection.z;
                        break;
                case '%':
                        curchar = *inptr++;
                        curstate.udirection.x = -curstate.udirection.x;
                        curstate.udirection.y = -curstate.udirection.y;
                        curstate.udirection.z = -curstate.udirection.z;
                        curstate.ldirection.x = -curstate.ldirection.x;
                        curstate.ldirection.y = -curstate.ldirection.y;
                        curstate.ldirection.z = -curstate.ldirection.z;
                        break;
                 case '+':
                        dang = getfloat();
                        if (dang != 0 ){
                                dang = deg2rad(dang);
                                rotate(&(curstate.ldirection), &(curstate.fdirection), &v, dang);
                                curstate.fdirection = v;
                                rotate(&(curstate.ldirection), &(curstate.udirection), &v, dang);
                                curstate.udirection = v;

                        }
                        else{
                                rotate(&(curstate.ldirection), &(curstate.fdirection), &v, curstate.deltaangle);
                                curstate.fdirection = v;
                                rotate(&(curstate.ldirection), &(curstate.udirection), &v, curstate.deltaangle);
                                curstate.udirection = v;
                        }
                        break;
                        
                 case '-':
                        dang = getfloat();
                        if(dang != 0 ){
                                dang = deg2rad(dang);
                                rotate(&(curstate.ldirection), &(curstate.fdirection), &v, -dang);
                                curstate.fdirection = v;
                                rotate(&(curstate.ldirection), &(curstate.udirection), &v, -dang);
                                curstate.udirection = v;
                        }
                        else{
                                rotate(&(curstate.ldirection), &(curstate.fdirection), &v, -curstate.deltaangle);
                                curstate.fdirection = v;
                                rotate(&(curstate.ldirection), &(curstate.udirection), &v, -curstate.deltaangle);
                                curstate.udirection = v;
                        }
                        break;

                 case '&':
                        dang = getfloat();
                        if(dang != 0){
                                dang = deg2rad(dang);
                                rotate(&(curstate.udirection), &(curstate.fdirection), &v, dang);
                                curstate.fdirection = v;
                                rotate(&(curstate.udirection), &(curstate.ldirection), &v, dang);
                                curstate.ldirection = v;
                        }                                
                        else {
                                rotate(&(curstate.udirection), &(curstate.fdirection), &v, curstate.deltaangle);
                                curstate.fdirection = v;
                                rotate(&(curstate.udirection), &(curstate.ldirection), &v, curstate.deltaangle);
                                curstate.ldirection = v;
                        }
                        break;
                 case '^':
                        dang = getfloat();
                        if( dang != 0){
                                dang = deg2rad(dang);
                                rotate(&(curstate.udirection), &(curstate.fdirection), &v, -dang);
                                curstate.fdirection = v;
                                rotate(&(curstate.udirection), &(curstate.ldirection), &v, -dang);
                                curstate.ldirection = v;                                
                        }
                        else{
                                rotate(&(curstate.udirection), &(curstate.fdirection), &v, -curstate.deltaangle);
                                curstate.fdirection = v;
                                rotate(&(curstate.udirection), &(curstate.ldirection), &v, -curstate.deltaangle);
                                curstate.ldirection = v;
                        }
                        break;
                 case '<':
                        dang = getfloat();
                        if(dang != 0 ){
                                dang = deg2rad(dang);
                                rotate(&(curstate.fdirection), &(curstate.ldirection), &v, dang);
                                curstate.ldirection = v;
                                rotate(&(curstate.fdirection), &(curstate.udirection), &v, dang);
                                curstate.udirection = v;

                        }
                        else{
                                rotate(&(curstate.fdirection), &(curstate.ldirection), &v, curstate.deltaangle);
                                curstate.ldirection = v;
                                rotate(&(curstate.fdirection), &(curstate.udirection), &v, curstate.deltaangle);
                                curstate.udirection = v;
                        }
                        break;
                 case '>':
                        dang = getfloat();
                        if(dang != 0 ){
                                dang = deg2rad(dang);
                                rotate(&(curstate.fdirection), &(curstate.ldirection), &v, -dang);
                                curstate.ldirection = v;
                                rotate(&(curstate.fdirection), &(curstate.udirection), &v, -dang);
                                curstate.udirection = v;

                        }
                        else{
                                rotate(&(curstate.fdirection), &(curstate.ldirection), &v, -curstate.deltaangle);
                                curstate.ldirection = v;
                                rotate(&(curstate.fdirection), &(curstate.udirection), &v, -curstate.deltaangle);
                                curstate.udirection = v;
                        }
                        break;
                 case ';':
                        dang = getfloat();
                        if(dang == 0 ) dang = 1 / deflscale;
                        curstate.deltaangle = curstate.deltaangle * dang;

                        break;
                 case ':':
                        dang = getfloat();
                        if (dang == 0) dang = deflscale;
                        curstate.deltaangle = curstate.deltaangle * dang;

                        break;
                 case '[':
                 case '{':

                        if( stacktop >= STACKDEPTH-1){

                                return (INTERPRETSTACKOVERFLOW);
                        }
                        pushstate(curstate);

                        if (curchar == '{'){

                                track=getfloat();
                                if(track>0)
                                    curstate.track=track-1;
                                else{

                                    curstate.track=(curstate.track+1)%MAXTRACKS;
                                }
                                curstate.inpoly = 1;
                        }
                        else {
                          curchar = *inptr++;
                        }


                        break;
                case ']':
                case '}':
                        if(curchar==']')holdtime=curstate.cumtime;
#ifdef STACKUNDERFLOWABORT
                        if(stacktop<0) return(INTERPRETSTACKUNDERFLOW);
#endif
                        if(curchar==']'){
                            holdtime=curstate.cumtime;
                            curstate = popstate();
                            curstate.cumtime=holdtime;
                        }
                        else if(curchar == '}'){
                              curstate = popstate();
                        }

                        curchar = *inptr++;
                        break;
                case '\\':
                        if(timestacktop<STACKDEPTH-1)
                                  pushtime(curstate.cumtime);

                        track=(int)getfloat();

                        if(track>0)
                            curstate.track=track-1;


                        break;

                case '/':
                        curstate.cumtime=poptime();
                        curchar = *inptr++;
                        break;
                case 'c':
                        clr = (int)(getfloat());
                        if( clr > 0)
                                curstate.clr = clr;
                        else curstate.clr = (curstate.clr + 1) % (maxcolor) + 1;
                        break;

                case '*':
                        track=(int)getfloat();

                        if(track>0)
                            curstate.track=track-1;


                        break;
        
                case '\'':
                        lscale = getfloat();
                        if(lscale > 0 )
                                curstate.length = lscale * curstate.length;
                        else
                                curstate.length = deflscale * curstate.length;
                        break;
                case '!':
                        lscale = getfloat();
                        if(lscale > 0)
                                curstate.thickness = lscale * curstate.thickness;
                        else
                                curstate.thickness = .7 * curstate.thickness;
                        break;
                case '?':
                        lscale = getfloat();
                        if(lscale > 0 )
                                curstate.thickness = lscale * curstate.thickness;
                        else
                                curstate.thickness = 1.0 / .7 * curstate.thickness;
                        break;

                case '"':
                        lscale = getfloat();
                        if(lscale > 0 )
                                curstate.length = lscale * curstate.length;
                        else
                                curstate.length = 1.0 / deflscale * curstate.length;
                        break;

                case '~':
                        maxrandomturn = getfloat();
                        maxrandomturn = PI * maxrandomturn / 180.0;
                        if( maxrandomturn > 0){
                                xturn = maxrandomturn - 2 * RND * maxrandomturn;

                                xrot(&(curstate.fdirection), &u, xturn);
                                curstate.fdirection = u;
                                xrot(&(curstate.udirection), &u, xturn);
                                curstate.udirection = u;
                                xrot(&(curstate.ldirection), &u, xturn);
                                curstate.ldirection = u;
                               
                                yturn = maxrandomturn - 2 * RND * maxrandomturn;

                                yrot(&(curstate.fdirection), &u, yturn);
                                curstate.fdirection = u;
                                yrot(&(curstate.udirection), &u, yturn);
                                curstate.udirection = u;
                                yrot(&(curstate.ldirection), &u, yturn);
                                curstate.ldirection = u;

                                zturn = maxrandomturn - 2 * RND * maxrandomturn;

                                zrot(&(curstate.fdirection), &u, zturn);
                                curstate.fdirection = u;
                                zrot(&(curstate.udirection), &u, zturn);
                                curstate.udirection = u;
                                zrot(&(curstate.ldirection), &u, zturn);
                                curstate.ldirection = u;
                        }
                        else{                               

                                xturn = 2 * RND * PI;

                                xrot(&(curstate.fdirection), &u, xturn);
                                curstate.fdirection = u;
                                xrot(&(curstate.udirection), &u, xturn);
                                curstate.udirection = u;
                                xrot(&(curstate.ldirection), &u, xturn);
                                curstate.ldirection = u;
                                yturn = 2 * RND * PI;

                                yrot(&(curstate.fdirection), &u, yturn);
                                curstate.fdirection = u;
                                yrot(&(curstate.udirection), &u, yturn);
                                curstate.udirection = u;
                                yrot(&(curstate.ldirection), &u, yturn);
                                curstate.ldirection = u;
                                zturn = 2 * RND * PI;

                                zrot(&(curstate.fdirection), &u, zturn);
                                curstate.fdirection = u;
                                zrot(&(curstate.udirection), &u, zturn);
                                curstate.udirection = u;
                                zrot(&(curstate.ldirection), &u, zturn);
                                curstate.ldirection = u;
                        }
                        break;
                case 'm':
                        mapnumber=(int)getfloat();
                        mapnumber %= MAXMAPS;
                        curstate.mymap=&(maps[mapnumber]);
                        break;
                case 't':
                        transpose=getfloat();
                        curstate.transpose=transpose;
                        break;
                case 'd':
                        dfact=getfloat();
                        if(dfact<=0.0)
                            curstate.dfact=1.0;
                        else{
                            curstate.dfact=dfact;
                        }
                        break;
                case 'v':
                        vfact=getfloat();
                        if(vfact<=0.0)
                            curstate.vfact=1.0;
                        else{
                            curstate.vfact=vfact;
                        }
                        break;

                case 'T':
                        transpose=getfloat();
                        if(transposestack_p){

                            if(transpose==0) curstate.transpose=poptranspose();
                            else{
                              if(transposestacktop<STACKDEPTH-1)
                                  pushtranspose(curstate.transpose);
                              curstate.transpose+=transpose;
                            }
                        }
                        break;
                
                case 'D':
                        dfact=getfloat();
                        if(factstacks_p){

                            if(dfact<=0.0) curstate.dfact=popdfact();
                            else{
                              if(dfactstacktop<STACKDEPTH-1)
                                  pushdfact(curstate.dfact);
                              curstate.dfact*=dfact;
                            }
                        }
                        break;
                case 'V':
                        vfact=getfloat();
                        if(factstacks_p){

                            if(vfact<=0.0) curstate.vfact=popvfact();
                            else{
                               if(vfactstacktop<STACKDEPTH-1)
                                  pushvfact(curstate.vfact);
                               curstate.vfact*=vfact;
                            }
                        }
                        break;
                case '(':
                        getfloat();
                        break;
                
                default:
                        curchar = *inptr++;
        }/*end switch*/
        if(mode==0)
               getvariablelimits();
        if(curstate.cumtime>maxcumtime)
               maxcumtime=curstate.cumtime;

        if( kbhit()&&(getch()==27) ){

              interpretret=INTERPRETABORT;
              break;

        }

     }


     signal(SIGFPE, SIG_DFL);

     l_printf("\n");
     return (interpretret);
}

float  getfloat(){
        int inparen=0;
        char buf[80]="";
        char *bptr=buf;
        float ret;
        curchar = *inptr++;

        if(curchar == '(' ){
                curchar = *inptr++;
                if( curchar == '-' ||  curchar == '+'){
                /* + and - only allowed if the number is in parentheses
                   since + and - are special lsystem characters*/

                        *bptr=curchar;
                        bptr++;
                        curchar = *inptr++;
                }
                inparen = 1;
        }
        while( (curchar>='0' && curchar<='9') || curchar=='.' || curchar== ')'){

                *bptr = curchar; bptr++;
                curchar = *inptr++;
        }
        ret=atof(buf);
        return ret;

}


char * changefileext(char * origfilename,char * newfilename, char * newext){

        char * extptr;
        if(*origfilename&& origfilename !=NULL){
           strcpy (newfilename,origfilename);
           extptr=get_extension(newfilename);
           if(*extptr=='\0')
               sprintf(extptr,".%s",newext);
           else{
             *extptr='\0'; /*chop off the extension*/
             strcat(newfilename,newext);
           }
           return (newfilename);
        }
        else return (NULL);
}

int writeparameters2miditext(){
        char textbuf1[612];
        char textbuf2[612];
        long sz;

        sprintf (textbuf1,"LMUSe v%s: %s %s: ",PROGRAMVERSION,get_filename(rulefile), originalmutated?"(mutated)":"");
        sprintf(textbuf2,"recursions=%s, angle=%3.2f, Map file: %s ",numrecursestring,deltaangledeg,get_filename(inifile));

        strcat(textbuf1,textbuf2);

        sz=strlen(textbuf1);
        mf_write_meta_event(0L, text_event, (unsigned char *)textbuf1, sz);

        return 0;
}

/***/
char prg2channel[255];
char prgsontrack[MAXTRACKS][255];
int counttrackchannels(){
    int tracknumber;
    int i,j,n=0;
    //int newnumberoftracks=0;
    MIDINOTELIST * L,* next_node,* first_node;
    MIDICHANEVENT m;
    unsigned char data1[2];
    char lastprog=-1;
    unsigned char stat;
    unsigned char channel;
    int lastassignedchannel=-1;
    for(i=0;i<MAXTRACKS;i++){
           for(j=0;j<255;j++){
                     prgsontrack[i][j]=0;

           }
    }
    for(j=0;j<255;j++){
            prg2channel[j]=-1;
    }
    for(tracknumber=0;tracknumber<MAXTRACKS;tracknumber++){
        if(trackflags[tracknumber]&ACTIVE){
             if(tracklist[tracknumber]==NULL) continue;
             //channel=trackchannel[whichtrack];
             L=tracklist[tracknumber];
             first_node=L;
             next_node=L->next;
             lastprog=-1;
             while( L!=NULL){
                    m=L->m;
                    stat=m.status&0xF0;
                    channel=m.status&0x0F;
                    data1[0]=m.data1;
                    if(stat==PRG_CHG){

                       lastprog=data1[0];
                       prgsontrack[tracknumber][(int)lastprog]=1;
                       if(prg2channel[(int)lastprog]==-1){
                          if(channel!=9){
                              lastassignedchannel++;
                              if(lastassignedchannel>=9)lastassignedchannel++;
                              lastassignedchannel%=MAXTRACKS;
                              prg2channel[(int)lastprog]=lastassignedchannel;
                          }

                       }
                    }
                    else if(stat==NOTEON){
                       if(lastprog==-1){
                           prgsontrack[tracknumber][0]=1;
                           lastprog=0;
                           if(prg2channel[(int)lastprog]==-1){
                             if(channel!=9){
                                lastassignedchannel++;
                                if(lastassignedchannel>=9)lastassignedchannel++;
                                lastassignedchannel%=MAXTRACKS;
                                prg2channel[(int)lastprog]=lastassignedchannel;
                             }


                           }
                       }
                    }

     
                    L=L->next;

             }


        }

    }
    for(i=0;i<MAXTRACKS;i++){
           for(j=0;j<255;j++){
                     if(prgsontrack[i][j])
                        n++;
           }
    }
    return n;
}
int writesplittracklist (int whichtrack)
{

        MIDINOTELIST * L,* next_node,* first_node;
        MIDICHANEVENT m;
        int i,j,n,tracknumber;
        int notesstillon[127];
        int usingmyprog=1;
        unsigned char stat;
        unsigned char channel;
	unsigned char data1[2]/*,data2[2]*/;
        unsigned char myprog=0;
        unsigned char lastprog=-1;
	long t,cum_time,holdt=0;
	//unsigned char lastprog=-1;
        if(whichtrack==0){
                if(writeparameters_p)
	           writeparameters2miditext();
		mf_write_tempo((long)mtempo);
		return(1);
	}
        for(i=0;i<127;i++)
             notesstillon[i]=0;
        whichtrack=whichtrack-1;

        n=0;
        for(tracknumber=0;tracknumber<MAXTRACKS;tracknumber++){

             for(j=0;j<255;j++){

                  if(prgsontrack[tracknumber][j]){


                      if(n==whichtrack){
                        //whichtrack=tracknumber;
                        myprog=j;
                        break;
                      }
                      else n++;
                  }
             }
             if(n>=whichtrack&&j<255) break;

        }

        channel=trackchannel[tracknumber];
        L=tracklist[tracknumber];
        first_node=L;
        next_node=L->next;
        n=0;
        cum_time=0L;
        holdt=0L; t=0L;
        data1[0]=myprog;
        lastprog=myprog;
        if(channel!=9)
           channel=prg2channel[myprog];
        mf_write_midi_event(t+holdt,PRG_CHG,channel,data1 ,1L);
	while( L!=NULL){

               m=L->m;
               t=m.t;
               stat=m.status&0xF0;
               //channel=m.status&0x0F;
               data1[0]=m.data1;
               data1[1]=m.data2;
               if(stat==PRG_CHG){ /*we made lots of extra prg_chg events*/

                     if(data1[0]==myprog){
                         usingmyprog=1;
                         //if(lastprog!=data1[0]){
                         //  mf_write_midi_event(t+holdt, stat, channel, data1, 1L);
                         //  holdt=0L;
                         //}
                         //else
                           holdt+=t;
                     }
                     else{
                         usingmyprog=0;
                         holdt+=t;
                     }
                     lastprog=data1[0];

               }
               else if(stat==NOTEON){
                  if(usingmyprog){
                      mf_write_midi_event(t+holdt, stat, channel, data1, 2L);
                      notesstillon[data1[0]]++;
                      holdt=0L;
                  }
                  else holdt+=t;
               }
               else if(stat==NOTEOFF){
                  if(notesstillon[data1[0]]){
                      mf_write_midi_event(t+holdt, stat, channel, data1, 2L);
                      notesstillon[data1[0]]--;
                      holdt=0L;
                  }
                  else holdt+=t;
               }
               else holdt+=t; /*some event we are not saving */

               L=L->next;
               n++;
	}
	return n;
}/*end writesplittracklist()*/


int writetracklist (int whichtrack)
{

        MIDINOTELIST * L,* next_node,* first_node;
        MIDICHANEVENT m;
        int n,tracknumber;
        unsigned char stat;
        unsigned char channel;
	unsigned char data1[2] /*,data2[2]*/;
	long t,cum_time,holdt=0;

	unsigned char lastprog=-1;

	if(whichtrack==0){
                if(writeparameters_p)
	           writeparameters2miditext();
		mf_write_tempo((long)mtempo);
		return(1);
	}

        whichtrack=whichtrack-1;
        n=0;
        for(tracknumber=0;tracknumber<MAXTRACKS;tracknumber++){
             if(trackflags[tracknumber]&ACTIVE){
                  if(n==whichtrack){
                        whichtrack=tracknumber;
                        break;
                  }
                  else n++;
             }

        }
        channel=trackchannel[whichtrack];

        L=tracklist[whichtrack];
        first_node=L;
        next_node=L->next;
        n=0;
        cum_time=0L;
        holdt=0L;
	while( L!=NULL){

               m=L->m;
               t=m.t;
               stat=m.status&0xF0;

               data1[0]=m.data1;
               data1[1]=m.data2;
               if(stat==PRG_CHG){ /*we made lots of extra prg_chg events*/
                     if(lastprog!=data1[0]){
                         mf_write_midi_event(t+holdt,stat,channel,data1 ,1L);
                         lastprog=data1[0];
                         holdt=0L;
                     }
                     else holdt+=t;
               }
               else if(stat==NOTEON||stat==NOTEOFF){
                  mf_write_midi_event(t+holdt, stat, channel, data1, 2L);
                  holdt=0L;
               }
               else holdt+=t; /*some event we are not saving */

               L=L->next;
               n++;

	}
	return n;
}/*end writetracklist()*/
int saveproduction(){
        FILE *prod_fp;

        if((prod_fp = fopen(productionfilename,"w")) == 0L)
            l_printf("Unable to open production file for writing.\n");
        else{
             fputs(production,prod_fp);
             fclose(prod_fp);
        }

        return 0;
}

int savemidi(){

        int tracknumber;

        int numtracks=0;
        for(tracknumber=0;tracknumber<MAXTRACKS;tracknumber++){
               if(trackflags[tracknumber]&ACTIVE)
                      numtracks++;

        }

        if((savemf_fp = fopen(savemfname,"wb")) == 0L)
                  l_printf("\nUnable to open file for writing.\n");
        else{
                   l_printf("\nSaving midi interpretation to %s\n",savemfname);
                   Mf_putc = myputc;
                   if(splittracksbyprogram){
                       numtracks=counttrackchannels();
                       Mf_writetrack=writesplittracklist;
                   }
                   else
                       Mf_writetrack=writetracklist;
    


                   mfwrite(1,numtracks+1,division,savemf_fp);
                   fclose(savemf_fp);
        }

        return(0);
}



#define MAXCFGLINE 255
int readinifile(){
    FILE *fp;
    MAP * m=&maps[0];
    int mnum;
    char *bptr,*rptr,*eqptr,*lptr;
    char buffer[MAXCFGLINE+1];

    fp=fopen(inifile,"rt");
    if(fp==NULL) return -1;

    while(fgets(buffer,MAXCFGLINE,fp)){

        //formatline(buffer);

        bptr=buffer;
        while(isspace(*bptr)) bptr++;
        lptr=bptr;
        while(*lptr!='\0'){
           if(*lptr==commentchar||*lptr=='\n'){
              *lptr='\0';
              break;
           }
           lptr++;

        }
        if(*bptr== '@') break;/* "@" is lparser end mark*/
        if(*bptr!='\0'){
                        eqptr=strchr(bptr,'=');
                        if(eqptr!=NULL){
                             lptr=bptr;rptr=eqptr+1;
                             *eqptr='\0';
                             formatline(lptr);
                             while(isspace(*rptr)) rptr++;
                             if(!stricmp(lptr,"mapnumber")){
                                    mnum=atoi(rptr);
                                    if(mnum>=0&&mnum<MAXMAPS)
                                        m=&maps[mnum];
                                    else
                                        m=&maps[0];
                             }
                             if(!stricmp(lptr,"tempo")){
                                    tempo=atol(rptr);
                             }
                             else if(!stricmp(lptr,"transpose")){
                                    m->transpose=atoi(rptr);
                             }
                             else if(!stricmp(lptr,"pspread")){
                                    m->pspread=atof(rptr);
                                    if(m->pspread>PSPREADMAX) m->pspread=PSPREADMAX;
                                    if(m->pspread<-PSPREADMAX) m->pspread=-PSPREADMAX;

                             }
                             else if(!stricmp(lptr,"dspread")){
                                    m->dspread=atof(rptr);
                                    if(m->dspread>DSPREADMAX) m->dspread=DSPREADMAX;
                                    if(m->dspread<-DSPREADMAX) m->dspread=-DSPREADMAX;

                             }
                             else if(!stricmp(lptr,"vspread")){
                                    m->vspread=atof(rptr);
                                    if(m->vspread>VSPREADMAX) m->vspread=VSPREADMAX;
                                    if(m->vspread<-VSPREADMAX) m->vspread=-VSPREADMAX;
                             }
                             else if(!stricmp(lptr,"pitch")){
                                  formatline(rptr);
                                  if(!stricmp(rptr,"x"))
                                       m->pitch=&statevariablearray[X_VAR];
                                  else if(!stricmp(rptr,"y"))
                                       m->pitch=&statevariablearray[Y_VAR];
                                  else if(!stricmp(rptr,"z"))
                                       m->pitch=&statevariablearray[Z_VAR];

                                  else if(!stricmp(rptr,"forwardx")||!stricmp(rptr,"fx"))
                                       m->pitch=&statevariablearray[FX_VAR];
                                  else if(!stricmp(rptr,"forwardy")||!stricmp(rptr,"fy"))
                                       m->pitch=&statevariablearray[FY_VAR];
                                  else if(!stricmp(rptr,"forwardz")||!stricmp(rptr,"fz"))
                                       m->pitch=&statevariablearray[FZ_VAR];

                                  else if(!stricmp(rptr,"upx")||!stricmp(rptr,"ux"))
                                       m->pitch=&statevariablearray[UX_VAR];
                                  else if(!stricmp(rptr,"upy")||!stricmp(rptr,"uy"))
                                       m->pitch=&statevariablearray[UY_VAR];
                                  else if(!stricmp(rptr,"upz")||!stricmp(rptr,"uz"))
                                       m->pitch=&statevariablearray[UZ_VAR];
                                  else if(!stricmp(rptr,"leftx")||!stricmp(rptr,"lx"))
                                       m->pitch=&statevariablearray[LX_VAR];
                                  else if(!stricmp(rptr,"lefty")||!stricmp(rptr,"ly"))
                                       m->pitch=&statevariablearray[LY_VAR];
                                  else if(!stricmp(rptr,"leftz")||!stricmp(rptr,"lz"))
                                       m->pitch=&statevariablearray[LZ_VAR];

                                  else if(!stricmp(rptr,"length")||!stricmp(rptr,"statelength"))
                                       m->pitch=&statevariablearray[LENGTH_VAR];
                                  else if(!stricmp(rptr,"drawlength")||!stricmp(rptr,"dlength"))
                                       m->pitch=&statevariablearray[DRAWLENGTH_VAR];
                                  else if(!stricmp(rptr,"thickness")||!stricmp(rptr,"thick"))
                                       m->pitch=&statevariablearray[THICKNESS_VAR];
                             }
                             else if(!stricmp(lptr,"duration")){
                                  formatline(rptr);
                                  if(!stricmp(rptr,"x"))
                                       m->duration=&statevariablearray[X_VAR];
                                  else if(!stricmp(rptr,"y"))
                                       m->duration=&statevariablearray[Y_VAR];
                                  else if(!stricmp(rptr,"z"))
                                       m->duration=&statevariablearray[Z_VAR];

                                  else if(!stricmp(rptr,"forwardx")||!stricmp(rptr,"fx"))
                                       m->duration=&statevariablearray[FX_VAR];
                                  else if(!stricmp(rptr,"forwardy")||!stricmp(rptr,"fy"))
                                       m->duration=&statevariablearray[FY_VAR];
                                  else if(!stricmp(rptr,"forwardz")||!stricmp(rptr,"fz"))
                                       m->duration=&statevariablearray[FZ_VAR];

                                  else if(!stricmp(rptr,"upx")||!stricmp(rptr,"ux"))
                                       m->duration=&statevariablearray[UX_VAR];
                                  else if(!stricmp(rptr,"upy")||!stricmp(rptr,"uy"))
                                       m->duration=&statevariablearray[UY_VAR];
                                  else if(!stricmp(rptr,"upz")||!stricmp(rptr,"uz"))
                                       m->duration=&statevariablearray[UZ_VAR];
                                  else if(!stricmp(rptr,"leftx")||!stricmp(rptr,"lx"))
                                       m->duration=&statevariablearray[LX_VAR];
                                  else if(!stricmp(rptr,"lefty")||!stricmp(rptr,"ly"))
                                       m->duration=&statevariablearray[LY_VAR];
                                  else if(!stricmp(rptr,"leftz")||!stricmp(rptr,"lz"))
                                       m->duration=&statevariablearray[LZ_VAR];

                                  else if(!stricmp(rptr,"length"))
                                       m->duration=&statevariablearray[LENGTH_VAR];
                                  else if(!stricmp(rptr,"drawlength")||!stricmp(rptr,"dlength"))
                                       m->duration=&statevariablearray[DRAWLENGTH_VAR];
                                  else if(!stricmp(rptr,"thickness")||!stricmp(rptr,"thick"))
                                       m->duration=&statevariablearray[THICKNESS_VAR];
                             }
                             else if( !stricmp(lptr,"velocity") || !stricmp(lptr,"volume")){
                                  formatline(rptr);
                                  if(!stricmp(rptr,"x"))
                                       m->volume=&statevariablearray[X_VAR];
                                  else if(!stricmp(rptr,"y"))
                                       m->volume=&statevariablearray[Y_VAR];
                                  else if(!stricmp(rptr,"z"))
                                       m->volume=&statevariablearray[Z_VAR];

                                  else if(!stricmp(rptr,"forwardx")||!stricmp(rptr,"fx"))
                                       m->volume=&statevariablearray[FX_VAR];
                                  else if(!stricmp(rptr,"forwardy")||!stricmp(rptr,"fy"))
                                       m->volume=&statevariablearray[FY_VAR];
                                  else if(!stricmp(rptr,"forwardz")||!stricmp(rptr,"fz"))
                                       m->volume=&statevariablearray[FZ_VAR];

                                  else if(!stricmp(rptr,"upx")||!stricmp(rptr,"ux"))
                                       m->volume=&statevariablearray[UX_VAR];
                                  else if(!stricmp(rptr,"upy")||!stricmp(rptr,"uy"))
                                       m->volume=&statevariablearray[UY_VAR];
                                  else if(!stricmp(rptr,"upz")||!stricmp(rptr,"uz"))
                                       m->volume=&statevariablearray[UZ_VAR];
                                  else if(!stricmp(rptr,"leftx")||!stricmp(rptr,"lx"))
                                       m->volume=&statevariablearray[LX_VAR];
                                  else if(!stricmp(rptr,"lefty")||!stricmp(rptr,"ly"))
                                       m->volume=&statevariablearray[LY_VAR];
                                  else if(!stricmp(rptr,"leftz")||!stricmp(rptr,"lz"))
                                       m->volume=&statevariablearray[LZ_VAR];

                                  else if(!stricmp(rptr,"length"))
                                       m->volume=&statevariablearray[LENGTH_VAR];
                                  else if(!stricmp(rptr,"drawlength")||!stricmp(rptr,"dlength"))
                                       m->volume=&statevariablearray[DRAWLENGTH_VAR];
                                  else if(!stricmp(rptr,"thickness")||!stricmp(rptr,"thick"))
                                       m->volume=&statevariablearray[THICKNESS_VAR];

                             }
                             else if( !stricmp(lptr,"scale") ){
                                  if(isdigit(*rptr)){
                                       user_defined_scale=string2scale(rptr);
                                       if(user_defined_scale!=NULL){
                                          scale2scalestring(user_defined_scale);
                                          m->scale=*user_defined_scale;
                                          strcpy(m->scalename,scalenames[7]);
                                          strcpy(scalenamestring,scalenames[7]);

                                       }
                                  }
                                  else{
                                       formatline(rptr);
                                       if(!stricmp(rptr,"twelvetone")){
                                          m->scale=scales[0];
                                          strcpy(m->scalename,scalenames[0]);
                                          strcpy(scalenamestring,scalenames[0]);
                                       }
                                       else if(!stricmp(rptr,"major")){
                                          m->scale=scales[1];
                                          strcpy(m->scalename,scalenames[1]);
                                          strcpy(scalenamestring,scalenames[1]);
                                       }
                                       else if(!stricmp(rptr,"penta1")){
                                          m->scale=scales[2];
                                          strcpy(m->scalename,scalenames[2]);
                                          strcpy(scalenamestring,scalenames[2]);
                                       }
                                       else if(!stricmp(rptr,"minor")){
                                          m->scale=scales[3];
                                          strcpy(m->scalename,scalenames[3]);                                          
                                          strcpy(scalenamestring,scalenames[3]);
                                       }
                                       else if(!stricmp(rptr,"blue1")){
                                          m->scale=scales[4];
                                          strcpy(m->scalename,scalenames[4]);
                                          strcpy(scalenamestring,scalenames[4]);
                                       }
                                       else if(!stricmp(rptr,"whole")){
                                          m->scale=scales[5];
                                          strcpy(m->scalename,scalenames[5]);
                                          strcpy(scalenamestring,scalenames[5]);
                                       }
                                       else if(!stricmp(rptr,"diminished")){
                                          m->scale=scales[6];
                                          strcpy(m->scalename,scalenames[6]);                                          
                                          strcpy(scalenamestring,scalenames[6]);
                                       }

                                  }
                             }
                             else if(!stricmp(lptr,"scalefn")){
                                       formatline(rptr);
                                       if(!stricmp(rptr,"constant")){
                                          m->scalefn=constantscale;
                                          strcpy(scalefnnamestring,scalefnnames[2]);
                                       }
                                       else if(!stricmp(rptr,"slideto")){
                                          m->scalefn=slidetoscale;
                                          strcpy(scalefnnamestring,scalefnnames[0]);

                                       }
                                       else if(!stricmp(rptr,"steps")){
                                          m->scalefn=scalesteps;
                                          strcpy(scalefnnamestring,scalefnnames[1]);

                                       }
                                       else if(!stricmp(rptr,"ignore")){
                                          m->scalefn=ignscale;
                                          strcpy(scalefnnamestring,"ignore");

                                       }

                             }
                             else if(!stricmp(lptr,"dmultiplier")){
                                  m->dmultiplier=4.0*fabs(atof(rptr));
                                  if(m->dmultiplier>4.0*DMULTMAX) m->dmultiplier=4.0*DMULTMAX;
                                  if(m->dmultiplier<0) m->dmultiplier=0;

                             }
                             else if(!stricmp(lptr,"tstack") ||!stricmp(lptr,"transposestack")){
                                       formatline(rptr);
                                       if(!stricmp(rptr,"1")||!stricmp(rptr,"yes")||!stricmp(rptr,"y")||!stricmp(rptr,"on")){
                                          transposestack_p=1;
                                          m->tstack=1;
                                       }
                                       else {
                                          transposestack_p=0;
                                          m->tstack=0;
                                       }
                             }
                             else if(!stricmp(lptr,"fstacks") ||!stricmp(lptr,"factorstacks")){
                                       formatline(rptr);
                                       if(!stricmp(rptr,"1")||!stricmp(rptr,"yes")||!stricmp(rptr,"y")||!stricmp(rptr,"on")){
                                          factstacks_p=1;
                                          m->fstacks=1;
                                       }
                                       else{
                                          factstacks_p=0;
                                          m->fstacks=0;
                                       }
                             }
                             else if(!stricmp(lptr,"seed") ||!stricmp(lptr,"randomseed")){
                                       rstart=(unsigned)atoi(rptr);
                                       lastseed=rstart;
                             }
                             else if( !stricmp(lptr,"writeparameters") ){
                                       formatline(rptr);
                                       if(!stricmp(rptr,"0")||!stricmp(rptr,"no")||!stricmp(rptr,"n")||!stricmp(rptr,"off")){
                                          writeparameters_p=0;

                                       }
                                       else {
                                          writeparameters_p=1;

                                       }

                             }

                        }
        }

    }

    fclose(fp);
    return 0;
}



#define MUTATESUCCESS 1
#define MUTATEFAILED -1
#define NOMUTATION 0
#define MAXMUTATEATTEMPTS 100
int mutaterules(){
        int mutateret;
        int numattempts=0;
        while( (mutateret=L_mutate())==NOMUTATION && numattempts<MAXMUTATEATTEMPTS){
              numattempts++;
        }
        if(mutateret>0){
             originalmutated=1;
        }
        return 0;
}

FILE * mutatedfp;

int savemutatedrules(){
        int i;

        if((mutatedfp = fopen(mutatefilename,"wt")) == 0L){
            l_printf("\nUnable to open mutation file for writing.\n");
            return -1;
        }
        else{
             l_printf("\nSaving mutated rules to %s\n",mutatefilename);
             fprintf(mutatedfp,"%s\n",numrecursestring);
             fprintf(mutatedfp,"%f\n",deltaangledeg);
             fprintf(mutatedfp,"%f\n",thick);
             fprintf(mutatedfp,"%s\n",axiom);
 
             for (i = 0; i < MAXRULES; i++) {
                 if (rules[i] == NULL)
                 break;
                 fprintf(mutatedfp,"%s\n",rules[i]);
             }
             fprintf(mutatedfp,"%c",'@');
             fclose(mutatedfp);
 
        }
        return 0;
}


